# coding: utf-8

"""
    FINBOURNE ConfigurationService API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic.v1 import BaseModel, Field, constr
from lusid_configuration.models.resource_id import ResourceId

class CreateConfigurationSet(BaseModel):
    """
    The information required to create a new configuration set  # noqa: E501
    """
    id: ResourceId = Field(...)
    type: constr(strict=True, min_length=1) = Field(..., description="The type (personal or shared) of the new configuration set")
    description: Optional[constr(strict=True, max_length=255, min_length=0)] = Field(None, description="The description of the new configuration set")
    __properties = ["id", "type", "description"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateConfigurationSet:
        """Create an instance of CreateConfigurationSet from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of id
        if self.id:
            _dict['id'] = self.id.to_dict()
        # set to None if description (nullable) is None
        # and __fields_set__ contains the field
        if self.description is None and "description" in self.__fields_set__:
            _dict['description'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateConfigurationSet:
        """Create an instance of CreateConfigurationSet from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateConfigurationSet.parse_obj(obj)

        _obj = CreateConfigurationSet.parse_obj({
            "id": ResourceId.from_dict(obj.get("id")) if obj.get("id") is not None else None,
            "type": obj.get("type"),
            "description": obj.get("description")
        })
        return _obj
